<?php

namespace AppBundle\Repository;
use AppBundle\Entity\Project;
use Doctrine\Common\Collections\ArrayCollection;
use AppBundle\Entity\User;

/**
 * TimeslotRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class TimeslotRepository extends \Doctrine\ORM\EntityRepository
{
    public function findByUser($user, $beginInterval, $endInterval, $asEmployee, $project)
    {
        if ($beginInterval == null) $beginInterval = new \DateTime("1970-1-1");
        if ($endInterval == null) $endInterval = new \DateTime("2999-1-1");

        if ($asEmployee) {
            return $this->_em->createQuery(
                'SELECT t FROM AppBundle:Timeslot t JOIN t.job j JOIN AppBundle:User u
                  WHERE (j MEMBER OF u.attending AND u.id = :u AND j.project = :p AND t.date BETWEEN :begin AND :end)'
            )
                ->setParameter(':u', $user->getId())
                ->setParameter(':p', $project ? $project->getId() : '%')
                ->setParameter(':begin', $beginInterval->format("Y-m-d"))
                ->setParameter(':end', $endInterval->format("Y-m-d"))
                ->getResult();
        }
        else {
            return $this->_em->createQuery(
                'SELECT t FROM AppBundle:Timeslot t JOIN t.job j JOIN AppBundle:User u
                  WHERE (j MEMBER OF u.supervising AND u.id = :u AND j.project = :p AND t.date BETWEEN :begin AND :end)'
            )
                ->setParameter(':u', $user->getId())
                ->setParameter(':p', $project ? $project->getId() : '%')
                ->setParameter(':begin', $beginInterval->format("Y-m-d"))
                ->setParameter(':end', $endInterval->format("Y-m-d"))
                ->getResult();
        }

        return null;
    }

    public function countOccupied(\DateTime $dateTime, Project $project, User $user) {
        $a1 = clone ($dateTime -> setTime(0, 0, 0));
        $a2 = clone ($dateTime -> setTime(23, 59, 59));
        $timeslots = new ArrayCollection($this -> findByUser($user, $a1, $a2, false, $project));
        $res = new ArrayCollection();

        foreach ($user -> getSupervising() as $job) {
            $timeslotsByJob = $timeslots -> filter(function ($timeslot) use ($job) {
                return $timeslot -> getJob() == $job;
            });

            if ($timeslotsByJob -> isEmpty()) continue;

            $taken = 0;
            $total = 0;

            foreach($timeslotsByJob as $timeslot) {
                $taken += $timeslot -> getTakenSpots();
                $total += $timeslot -> getCapacity();
            }

            $res -> set($job -> getName(), $total - $taken);
        }

        return $res;
    }
}
